#!/usr/bin/python
# -*- coding: utf-8 -*-

import pygame
from pygame.locals import *

from pygame.sprite import Sprite

from math import sin, cos, radians

MAGENTA  = (255, 0, 255)
VELOCIDAD = 10

class Bala(pygame.sprite.Sprite):

	def __init__(self, autor, origen_disparo, angulo):

		#print "Bala ==> ", origen_disparo
		pygame.sprite.Sprite.__init__(self)

		self.autor = autor
		self.image = pygame.image.load("bala.bmp")
		self.image.set_colorkey(MAGENTA)
		self.rect = self.image.get_rect()

		self.rect.x, self.rect.y = origen_disparo
		self.dx, self.dy = self.get_vector(angulo)

		self.Actualizar()

	def get_vector(self, angulo):
	# Recibe un ángulo que da orientación al disparo
	# Devuelve el incremento de puntos x,y hasta que desaparezca la bala
		x = int(cos(radians(angulo)) * VELOCIDAD)
		y = int(sin(radians(angulo)) * VELOCIDAD)
		return x,y

	def Actualizar(self):
		self.rect.x += self.dx
		self.rect.y += self.dy
		return self.rect.x, self.rect.y


		

