#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygame
from pygame.locals import *

import gc
gc.enable()

VELOCIDAD = 40

class JAMtank():

	def __init__(self):

		self.resolucion_monitor = None # tupla (ancho, alto)
		self.ventana = None
		self.clock = None
		self.protagonista = None  # grupo de sprites que contiene al protagonista
		self.fondo = None
		self.estado = None
		self.disparos = pygame.sprite.RenderUpdates()

		self.Run() # ejecuta el juego. Para mantener compatibilidad con adaptador de sugar hay que eliminar este llamado.

	def Run(self):
	# Comienza el juego

		self.resolucion_monitor = (800,600)
		#self.resolucion_monitor = self.get_resolucion_actual_del_monitor()

		self.set_entorno() # Se configura todo a gusto. Va acá y no en __init__ para mantener la compatibilidad con el adaptador de sugar

		self.actualizar()
		pygame.display.update()

		print "*** Entrando en Bucle Principal . . ."
		self.estado = "En Juego"

		while self.estado == "En Juego":
			#gc.collect()
			self.clock.tick(VELOCIDAD)
			pygame.event.pump()
			event = pygame.event.poll() # Obtiene un solo evento de la lista
			if event.type == pygame.KEYDOWN or event.type == pygame.KEYUP:
				self.detectordeEventos(event)
		        self.actualizar()
			pygame.event.clear()

		if self.estado == "Terminar":
			print "*** Cerrando pygame y Saliendo del Juego ***"
			import sys
			pygame.quit()
			sys.exit()

	def detectordeEventos(self, event):
	# escucha eventos del teclado y los procesa

		#while gtk.events_pending(): # Necesario para que funcione el adaptador pygame-sugar
			#gtk.main_iteration()

		teclas = pygame.key.get_pressed()

		# girar en movimiento
		if teclas[pygame.K_UP] and teclas[pygame.K_RIGHT]:# adelante - derecha
			self.protagonista.evento(pygame.K_UP)
			self.protagonista.evento(pygame.K_RIGHT)
		elif teclas[pygame.K_UP] and teclas[pygame.K_LEFT]:# adelante - izquierda
			self.protagonista.evento(pygame.K_UP)
			self.protagonista.evento(pygame.K_LEFT)
		elif teclas[pygame.K_DOWN] and teclas[pygame.K_RIGHT]:# atras - derecha
			self.protagonista.evento(pygame.K_DOWN)
			self.protagonista.evento(pygame.K_LEFT)
		elif teclas[pygame.K_DOWN] and teclas[pygame.K_LEFT]:# atras - izquierda
			self.protagonista.evento(pygame.K_DOWN)
			self.protagonista.evento(pygame.K_RIGHT)
		# moverse sin girar
		elif teclas[pygame.K_UP] and not teclas[pygame.K_DOWN]:# adelante
			self.protagonista.evento(pygame.K_UP)
		elif teclas[pygame.K_DOWN] and not teclas[pygame.K_UP]:# atras
			self.protagonista.evento(pygame.K_DOWN)
		# girar sin moverse
		elif teclas[pygame.K_RIGHT] and not teclas[pygame.K_LEFT]:# derecha
			self.protagonista.evento(pygame.K_RIGHT)
		elif teclas[pygame.K_LEFT] and not teclas[pygame.K_RIGHT]:# izquierda
			self.protagonista.evento(pygame.K_LEFT)

		# Disparar
		if teclas[pygame.K_LCTRL]:
			self.protagonista.evento(pygame.K_LCTRL)

		# salir
		elif teclas[pygame.K_ESCAPE]:# salir
			self.estado = "Terminar"
		else:# Otros eventos
			pass

	def crear_disparo(self, autor, origen_disparo, angulo):
	# Genera un disparo
		from Bala import Bala
		bala = Bala(autor, origen_disparo, angulo)
		self.disparos.add(bala)

        def actualizar(self):
	# dibuja los sprites y el fondo

		self.ventana.blit(self.fondo, (0,0))
		pygame.display.update(self.protagonista.draw(self.ventana)) # dibuja el personaje en la nueva posicion, devolviendo rectangulos modificados
		for bala in self.disparos:
			x, y = bala.Actualizar()
			ancho_monitor, alto_monitor = self.resolucion_monitor
			if x < 0 or x > ancho_monitor or y < 0 or y > alto_monitor:
			# Si se sale de la pantalla se elimina
				bala.kill()
				print "Bala eliminada"

		pygame.display.update(self.disparos.draw(self.ventana))

		'''
		color = (255,255,255)
		pygame.draw.rect(self.ventana, color, self.protagonista.base.rect, 0)
		pygame.display.update() '''

	def set_entorno(self):
	# Configurar entorno de video e inicializar los módulos necesarios

		#-----------------------------------------------------------------------------
		# Inicializando módulos
		pygame.init()
		pygame.display.set_mode(self.resolucion_monitor, 0, 0)
		# Eventos bloqueados
		pygame.event.set_blocked([MOUSEMOTION, MOUSEBUTTONUP, MOUSEBUTTONDOWN, JOYAXISMOTION, JOYBALLMOTION, JOYHATMOTION, JOYBUTTONUP, JOYBUTTONDOWN])
		# Eventos permitidos
		pygame.event.set_allowed([QUIT, ACTIVEEVENT, KEYDOWN, KEYUP, VIDEORESIZE, VIDEOEXPOSE, USEREVENT])
		# habilitar la repeticion de teclas
		pygame.key.set_repeat(5, 5)# el 1º numero es demora en 1º repeticion y latencia para las siguientes

		#-----------------------------------------------------------------------------
		# Cargando cosas
		self.clock = pygame.time.Clock() # un reloj pygame
		self.fondo = pygame.transform.scale(pygame.image.load("fondo.jpg"), self.resolucion_monitor).convert_alpha()
		self.ventana = pygame.display.get_surface() # la ventana del juego

		from Tanque import Tanque
		self.protagonista = Tanque(self.resolucion_monitor, self) # el tanque local

		pygame.mouse.set_visible(False)

	def get_resolucion_actual_del_monitor(self):
	# Devuelve la resolución actual del monitor
		pygame.display.init()
		ancho = pygame.display.Info().current_w
		alto = pygame.display.Info().current_h

		return (ancho, alto)

if __name__ == "__main__":
    	JAMtank()
